package com.example.hlk_sw16;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.InetAddress;
import java.net.MulticastSocket;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import com.vveye.T2u;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.wifi.WifiInfo;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.os.SystemClock;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.CompoundButton.OnCheckedChangeListener;

@SuppressLint("NewApi") public class Login extends Activity {

	TextView tv=null;
	TextView tv3=null;
	private int port=0;
	
	EditText _txtPwd;
	CheckBox _checkbox;
	
	private boolean lanControlFlag=false;
	byte[] receivebuf=new byte[512];
	
	int intWaitTime=0;
	InetAddress address;
	InetAddress addr;
	DatagramPacket datapacket;
	DatagramPacket pack=null;
	MulticastSocket ms;
	String udpresult;
	
	String ip=null;
	private NetworkInfo info;
	private ConnectivityManager connectMgr;
	private WifiAdmin mWifiAdmin;   
	
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
	
		setContentView(R.layout.login);
		
		connectMgr = (ConnectivityManager) this.getSystemService(Context.CONNECTIVITY_SERVICE); 
		mWifiAdmin = new WifiAdmin(Login.this);
		
		tv=(TextView)findViewById(R.id.textView2);
		
		EditText _txtUUID = (EditText) findViewById(R.id.login_edit_account);// UUID
		_txtPwd = (EditText) findViewById(R.id.login_edit_pwd);// PWD
		
		SharedPreferences sharedPre1=getSharedPreferences("config", Context.MODE_PRIVATE);
        String username1=sharedPre1.getString("username", "");
        String password1=sharedPre1.getString("password", "");

        _txtUUID.setText(username1);
        _txtPwd.setText(password1);
        
        _checkbox=(CheckBox)findViewById(R.id.checkbox);
		_checkbox.setOnCheckedChangeListener(listener);
//        ArrayList<HashMap<Button,String>> listItem = new ArrayList<HashMap<Button,String>>();
//        HashMap<Button,String> map=new HashMap<Button,String>();
		Button btn_login=(Button)findViewById(R.id.login_btn_login);
//		map.put(btn_login, "");
//		listItem.add(map);
		
		btn_login.setOnClickListener(new OnClickListener(){
			public void onClick(View v)
			{
				Log.i("btn_login","˵½ť");
				P2PConnect();
				
				
				
				
			}
		});
		
		
	}
	
	
	private OnCheckedChangeListener listener = new OnCheckedChangeListener()  
    {  
		@Override
		public void onCheckedChanged(CompoundButton buttonView,
				boolean isChecked) {
			// TODO Auto-generated method stub
			switch (buttonView.getId())
			{
			case R.id.checkbox:
				if(isChecked)
					_txtPwd.setInputType(0x90);  //ʾ
				
				else
				{
					_txtPwd.setInputType(0x81);  //
				}
			}
		}              
    };
    
	protected void onStart()
	{
		super.onStart();
		Log.i("onStart","onStart");
		if(T2u.PortStatus((char)port)==1)
		{
			Log.i("btn_login","ѶϿԶ豸");
			T2u.Exit();
		}
		if(ms!=null)
		{
			ms.close();
			ms=null;
		}
		tv.setText(Login.this.getResources().getString(R.string.disconnected));
	}
	
	Handler handler = new Handler(){   
	    public void handleMessage(Message msg) {  
	    	String str =(String)msg.obj;
//	    	int port =(int)msg.obj;
	    	switch(msg.what){
	    	case 1:
	    		tv.setText("Զ豸ͨ");
				String strIP = Utils.getIPAddress(true);
				Log.i("IP", "IP:" + strIP + "," + "Port:" +Integer.parseInt(str) );
				Intent intent1 = new Intent(Login.this, SW16.class );
				intent1.putExtra("strIP", strIP);
				intent1.putExtra("port", str );
				intent1.putExtra("flag","remote");
				startActivity(intent1);
	    		break;
	    	case 2:
	    		tv.setText(Login.this.getResources().getString(R.string.connecting));
	    		break;
	    	case 3:
	    		tv.setText(Login.this.getResources().getString(R.string.NotFound));
	    		T2u.Exit();
	    		break;
	    	case 4:
	    		tv.setText(Login.this.getResources().getString(R.string.pwderror));
	    		T2u.Exit();
	    	case 5:
	    		tv.setText(Login.this.getResources().getString(R.string.Notonline));
//	    		T2u.Exit();
	    	case 6:
	    		tv.setText(Login.this.getResources().getString(R.string.Notlinkservice));
	    		T2u.Exit();
	    	case 7:
	    		tv.setText(Login.this.getResources().getString(R.string.juyuwangconnecting));
	    		
	    		break;
	    	case 8:
	    		tv.setText(Login.this.getResources().getString(R.string.lanconnected));
				
	    		
				Intent intent2 = new Intent(Login.this, SW16.class );
				intent2.putExtra("strIP", str);
				intent2.putExtra("port", "8080" );
				intent2.putExtra("flag","lan");
				startActivity(intent2);
	    		break;
	    	case 9:
	    		tv.setText("δ");
	    		break;
	    	case 10:
	    		
	    		break;
	    		
	    		
	    	}
	    }     
	};  
	
	
		Thread mP2PConnect=null;
		private void P2PConnect() {
        	 
			if(mP2PConnect!=null)
			{
				mP2PConnect=null;
				
			}
				mP2PConnect=new Thread(new Runnable(){
					public void run()
					{
						
						//						Looper.prepare();
						// ȡ豸ID
						EditText edit_text = (EditText) findViewById(R.id.login_edit_account);// ı
						CharSequence edit_text_value = edit_text.getText();
						if (edit_text_value.length() == 0) {
//							setTitle("uuid Is Null");
							return;
						}
						String strUUID = edit_text_value.toString();// 豸ID
						if (strUUID.length() == 0)
							return;

						// ȡ豸ID
						EditText edit_text1 = (EditText) findViewById(R.id.login_edit_pwd);// ı
						CharSequence edit_text_value1 = edit_text1.getText();
						if (edit_text_value1.length() == 0) {
//							setTitle("password Is Null");
							return;
						}
						String strPwd = edit_text_value1.toString();// 
						if (strPwd.length() == 0)
							return;
						
						//ȡSharedPreferences
				        SharedPreferences sharedPre=getSharedPreferences("config", Context.MODE_PRIVATE);
				        //ȡEditor
				        Editor editor=sharedPre.edit();
				        //ò
				        editor.putString("username", strUUID);
				        editor.putString("password", strPwd);
				        //ύ
				        editor.commit();

				        
				        info = connectMgr.getActiveNetworkInfo();
						if(info==null)
						{
							System.out.println("δκ");//ûť
							Message mes=new Message();
							mes.what=9;
							handler.sendMessage(mes);
							
							//ʾδ
							
						}
						else if(info.getType() == ConnectivityManager.TYPE_WIFI)//wifi
						{
							System.out.println("ڵWIFI");
//							Message mes=new Message();
//							mes.what=10;
//							handler.sendMessage(mes);
							
							//ֻھ			
							//Զ
							
							if(!LanConnect(strUUID))
							{
								RemoteConnect(strUUID,strPwd);	
							}
							
							
							
						}
						else if(info.getType() == ConnectivityManager.TYPE_MOBILE)//ֻ
						{
							System.out.println("ڵֻƶ");
//							Message mes=new Message();
//							mes.what=11;
//							handler.sendMessage(mes);
							
							//ֻֻԶ
							RemoteConnect(strUUID,strPwd);
							
						}
						
						
						
						
						
					}
				});
				mP2PConnect.start();
			
			
		}
		
		
		
		public boolean LanConnect(String strUUID)
		{
			
			int ip=0;
			String strip=null;
			Message mes1=new Message();  
			mes1.what=7;
			mes1.obj="abc";
			handler.sendMessage(mes1); 
			
//				addr = InetAddress.getLocalHost();
//				ip=addr.getHostAddress().toString(); //ȡip 
//				ip=ip.substring(0,ip.lastIndexOf(".")+1)+"255";
			
			ip=mWifiAdmin.getIpAddress();
//				 mWifiAdmin.getIpAddress();
			 if(ip != 0){strip = ((ip & 0xff) + "." + (ip >> 8 & 0xff) + "." + (ip >> 16 & 0xff) + "." + "255");}
			System.out.println("ip="+ip);
			
			

			try {
				address = InetAddress.getByName(strip);
			} catch (UnknownHostException e2) {
				// TODO Auto-generated catch block
				e2.printStackTrace();
			}
			byte[] out=new String("HLK").getBytes();		
			datapacket = new DatagramPacket(out,out.length,address,988);
			pack=new DatagramPacket(receivebuf,receivebuf.length);
			

			if(ms!=null)
			{
				ms.close();
				ms=null;
			}
			if(ms==null)
			{
				try {
					ms=new MulticastSocket();
					ms.send(datapacket);
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				
				intWaitTime=0;
				while(true)
				{
					try {
							ms.setSoTimeout(1000);
							ms.receive(pack);
							udpresult = new String(pack.getData()).trim();
							if(udpresult.indexOf(strUUID)!=-1)
							{
								lanControlFlag=true;
								strip=pack.getAddress().toString();
								System.out.println("豸ipַΪ"+strip);
								System.out.println("ھҵ豸");
								
								if(strip.indexOf("/")!=-1){	strip=strip.substring(strip.indexOf("/")+1);	}
								Message mes11=new Message();  
								mes11.what=8;
								mes11.obj=strip;
								handler.sendMessage(mes11);
								
								return true;
							}
							
						
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				
					intWaitTime += 1;
					System.out.println("ڽо");
					if (intWaitTime > 3) 
					{
						System.out.println("δ豸");
						break;
					}	
				}
			}
			return false;
		}
		public void RemoteConnect(String strUUID,String strPwd)
		{

			int portstatus = 0;
			int intWaitTime = 0;

	        Message mes1=new Message();  
			mes1.what=2;
			mes1.obj="abc";
			System.out.println("ڽ......");
			handler.sendMessage(mes1); 
			
			// -------------SDKʼ------------------------
			try {
				T2u.Init("nat.vveye.net", (char) 8000, "");
			} catch (Exception e) {
				Log.i("P2PConnect","T2u.Init fail");
				return;
			}
			Log.i("P2PConnect","T2u.Init");
			
			// ---------豸-------------------------
			byte[] result = new byte[1500];
			int num = T2u.Search(result);
			String tmp;
			Log.i("P2PConnect","T2u.Search="+num);
			if (num > 0) {
				tmp = new String(result);
				Log.i("P2PConnect","Device:" + tmp);
			} else {
			}
			
			// ----------------ȴ---------------------

			while (T2u.Status() == 0) {
				SystemClock.sleep(1000);
				intWaitTime += 1;

//							setTitle("T2u.Status=" + T2u.Status());
				Log.i("P2PConnect","T2u.Status="+ T2u.Status());
				if (intWaitTime > 10) {
					break;
				}
			}
			Log.i("P2PConnect","T2u.Status");
			
//						setTitle("T2u.status -> " + T2u.Status());

			
			// ------------------- ض˿ӳ--------------------
			if (T2u.Status() == 1) {
				int ret;
				// ---------------ѯ豸Ƿ-----------------
				ret = T2u.Query(strUUID);
//							setTitle("T2u.Query:" + strUUID + " -> " + ret);
				Log.i("P2PConnect","T2u.Query:" + strUUID + " -> " + ret);
				if (ret > 0) {
					// ******************IP*********************
					// String strIP = Utils.getIPAddress(true);
					// setTitle("IP:" + strIP);
					// --------------ӳ˿-----------------
					port = T2u.AddPortV3(strUUID, strPwd, "127.0.0.1", (char)8080,(char)0); //strUUIDΪ˺ţstrPWDΪ
//								setTitle("T2u.add_port -> port:" + port);
					Log.i("P2PConnect","T2u.add_port -> port:" + port);
//								System.out.println("port="+port);
					while(portstatus==0)
					{
						SystemClock.sleep(1000);
						
						portstatus=T2u.PortStatus((char)port);
						System.out.println("portstatus="+portstatus);
						if(portstatus==1)
						{
							Message mes=new Message();  
					    	mes.what=1;
				        	mes.obj=Integer.toString(port);
							handler.sendMessage(mes); 
							System.out.println("Զ豸ͨ");	
						}else if(portstatus==0)
						{
							Message mes=new Message();  
							mes.what=2;
							mes.obj="abc";
							System.out.println("ڽ......");
							handler.sendMessage(mes); 
						}else if(portstatus==-1)
						{
							Message mes=new Message();  
							mes.what=3;
							mes.obj="abc";
							System.out.println("δҵ豸");
							handler.sendMessage(mes); 
						}else if(portstatus==-5)
						{
							Message mes=new Message();  
							mes.what=4;
							mes.obj="abc";
							System.out.println("");
							handler.sendMessage(mes); 	
						}
						
						
						
					}

				} else {
					Log.i("P2PConnect","豸");
					Message mes=new Message();  
					mes.what=5;
					mes.obj="abc";
					handler.sendMessage(mes); 
					
				}
			} else {
				Log.i("P2PConnect","δӷ");
				Message mes=new Message();  
				mes.what=6;
				mes.obj="abc";
				handler.sendMessage(mes); 
				
			}
	
		}
		
//		@Override
//		public boolean onKeyLongPress(int keyCode, KeyEvent event) {
//			Log.i("onKeyLongPress","ť");
//			return false;
			
//		}
		
//		public void onDestroy()
//		{
//			Log.i("onDestroy","onDestroy");	
//			T2u.Exit();
//			super.onDestroy();
//		}
}
